<template>
  <div>
    <el-card class="el-card">
      <el-form :model="filterQuery" class="query-form" size="mini" label-width="100px" v-show="showSearch">
        <el-row>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="单号:">
              <el-input v-model="filterQuery.billNo" placeholder="请输入单号"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="出入库类型:">
              <el-select v-model="filterQuery.mainAction" placeholder="请选择出入库类型" style="width: 90%">
                <el-option label="全部" value=""></el-option>
                <el-option label="入库" value="WareHouseIn"></el-option>
                <el-option label="出库" value="WareHouseOut"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="单据类型:">
              <el-select v-model="filterQuery.action" placeholder="请选择单据类型"
                         style="width: 90%"
                         clearable>
                <el-option
                  v-for="item in busTypes"
                  :key="item.name"
                  :label="item.name"
                  :value="item.action">
                  <span style="float: left">{{ item.name }}</span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="所属仓库:">
              <el-select v-model="filterQuery.invCode" placeholder="请选择所属仓库" clearable="true"
                         style="width: 90%"
                         @change="invChange"
              >
                <el-option
                  v-for="item in invList"
                  :key="item.name"
                  :label="item.name"
                  :value="item.code">
                  <span style="float: left">{{ item.name }}</span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="创建时间:">
              <el-date-picker
                :picker-options="pickerOptions"
                v-model="actDateRange"
                type="daterange"
                format="yyyy 年 MM 月 dd 日"
                value-format="yyyy-MM-dd"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                style="width: 90%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div class="top-right-btn">
        <el-button-group>
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button
            type="primary"
            icon="el-icon-refresh"
            @click="onReset"
          >重置
          </el-button>
          <el-button type="primary" icon="el-icon-search" @click="onSubmit"
          >查询
          </el-button
          >
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>
      <el-table v-loading="loading" :data="list" style="width: 100%" highlight-current-row
                border
                @current-change="handleSelectionChange">
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="扫码单据类型" prop="billTypeName"></el-table-column>
        <el-table-column label="订单号" prop="billNo" show-overflow-tooltip></el-table-column>
        <el-table-column label="来源订单号" prop="corpOrderId" show-overflow-tooltip></el-table-column>
        <el-table-column label="来源" prop="fromType">
          <template slot-scope="scope">
            <span>{{ fromTypeMap[scope.row.fromType] }}</span>
          </template>
        </el-table-column>
        <el-table-column label="往来单位" prop="fromName" width="220">
        </el-table-column>
        <el-table-column label="当前部门" prop="deptName" width="120">
        </el-table-column>
        <el-table-column label="当前仓库" prop="invName" width="120">
        </el-table-column>
        <el-table-column label="所属科室" prop="deptName" width="120" v-if="enableDept">
        </el-table-column>
        <el-table-column label="创建时间" prop="createTime" show-overflow-tooltip>
          <template slot-scope="scope">
            <i class="el-icon-time"></i>
            <span>{{ scope.row.createTime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="校验状态" prop="status" width="100">
          <template slot-scope="scope">
            <el-tag :type="statusFilterType(scope.row.status)">{{
                checkStatus[scope.row.status]
              }}
            </el-tag>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="160" fixed="right">
          <template slot-scope="scope">

            <el-button
              type="text"
              size="small"
              @click.native.stop="InvoiceRegister(scope.row)"
            >发票登记
            </el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total>0"
        :total="total"
        :limit.sync="filterQuery.limit"
        :page.sync="filterQuery.page"
        @pagination="getList"
      ></pagination>
    </el-card>

    <el-tabs type="border-card" style="margin: 15px">
      <!--单据业务详情-->
      <el-tab-pane>
        <span slot="label">订单 {{ currentRow.billNo }}-发票信息</span>
        <el-form :inline="true" :model="bizQuery" class="query-form" size="mini">
        </el-form>
        <el-table v-loading="bizDetailLoading" :data="bizDetailList" style="width: 100%" border
                  row-key="id"
        >
          <el-table-column label="序号" type="index"></el-table-column>
          <el-table-column
            label="规格型号"
            prop="ggxh"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="产品名称"
            prop="cpmctymc"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="批次号"
            prop="batchNo"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="机器编码"
            prop="machineNo"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column
            label="发票代码"
            prop="invoiceCode"
          ></el-table-column>

          <el-table-column
            label="发票编码"
            prop="invoiceEncode"
          ></el-table-column>
          <el-table-column
            label="开票日期"
            prop="invoiceDate"
          ></el-table-column>
          <el-table-column
            label="发票价格"
            prop="price"
          ></el-table-column>
          <el-table-column
            label="生产日期"
            prop="productDate"
          ></el-table-column>
          <el-table-column
            label="失效日期"
            prop="expireDate"
          ></el-table-column>

          <el-table-column
            label="备注"
            prop="remark"
            show-overflow-tooltip
          ></el-table-column>
          <el-table-column label="操作" width="160" fixed="right">
            <template slot-scope="scope">

              <el-button
                type="text"
                size="small"
                @click.native.stop="printOrder(scope.row)"
              >编辑
              </el-button
              >
              <el-button
                type="text"
                size="small"
                @click.native.stop="deleteInvoice(scope.row.id)"
              >删除
              </el-button
              >
              <el-button
                type="text"
                size="small"
                @click.native.stop="toViewCompanyCert(scope.row)"
              >预览
              </el-button
              >

            </template>
          </el-table-column>
        </el-table>
        <pagination
          v-show="bizTotal>0"
          :total="bizTotal"
          :page.sync="bizQuery.page"
          :limit.sync="bizQuery.limit"
          @pagination="getBizDetailList"
        />
      </el-tab-pane>
    </el-tabs>
    <el-dialog
      :title="发票编辑"
      :visible.sync="Upinvoice"
      :before-close="freshen"
      width="60%"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      v-if="Upinvoice"
    >
      <Dialog-invoice
        :closeDialog="closeAcceptDialog"
        :inputQuery="currentManufacturer"
      ></Dialog-invoice>
    </el-dialog>

    <el-dialog
      :title="formMap[formName]"
      :visible.sync="InvoiceRegisterv"
      width="60%"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      v-if="InvoiceRegisterv"
    >
      <InvoiceRegister
        :closeInvoice="closeInvoice"
        :inputQueryId="inputQueryId"
      ></InvoiceRegister>
    </el-dialog>
    <el-dialog
      title="单据验收"
      :visible.sync="acceptOrderVisible"
      width="80%"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      v-if="acceptOrderVisible"
    >
      <accept-order
        :closeDialog="closeAcceptDialog"
        :orderQuery="acceptQuery"
        v-on:childByValue="parentByFn"
      ></accept-order>
    </el-dialog>

  </div>
</template>

<script>
import {
  deleteByOrderId,
  getOrderList, rollUnReceivebackOrder,filterInvoice
} from "../../api/inout/order";
import {getLocalJoinByUser} from "@/api/basic/busType";
import {getInvListByUser} from "@/api/system/invWarehouse";
import {isBlank} from "@/utils/strUtil";
import {selectSysParamByKey} from "@/api/param/systemParamConfig";
import { filterListInvoice, getBizDetailList ,deleteById} from '@/api/inout/orderDetailBiz'
import {getCodeList} from "@/api/inout/code";
import AcceptOrder from "@/views/inout/DialogReviewOrder";
import DialogInvoice from "@/views/inout/DialogInvoice";
import InvoiceRegister from "@/views/inout/InvoiceRegister";

import {inspectionOrderPDFFromTemplateFile, orderPDFFromTemplateFile} from "@/api/itextpdf/orderPrint"


const formJson = {
  site_id: "",
  site_name: "",
  describe: "",
  ads: [],
};

export default {
  name: "IoCheckSuccessOrder",
  data() {
    return {
      BASE_URL: process.env.VUE_APP_BASE_API,
      showSearch: true,
      filterQuery: {
        id: "",
        billNo: null,
        mainAction: null,
        action: null,
        page: 1,
        limit: 10,
        startTime: null,
        endTime: null,
        invCode: this.$store.getters.locInvCode,
      },
      formName: 1,
      formMap: {
        1: "发票登记"
      },
      certFileUrl: "",
      Upinvoice:false,
      InvoiceRegisterv:false,
      checkStatus: {
        1: "草稿",
        2: "等待处理",
        3: "等待校验",
        4: "处理异常",
        5: "待验收",
        6: "校验异常",
        7: "审核通过",
        8: "审核拒绝",
        9: "正在处理"
      },
      storageList: [],
      invList: [],
      list: [],
      total: 0,
      loading: false,
      index: null,
      enableDept: false,
      fromTypeMap: {
        "1": "UDIMS平台",
        "2": "网页新增",
        "3": "pda即时校验",
        "4": "pda未校验",
        "5": "pc端扫码精灵",
        "6": "缺量补录单据",
        "7": "UDI供应商平台",
        "8": "平衡补录单据",
        "10": "手动补单",
        "11": "仓库盘点",
        "12": "采购计划",
        "13": "领用单据",
        "14": "第三方系统单据",
      },
      deleteData: {
        id: "",
        status: 10,
      },
      dialogTableVisible: false,
      formLoading: false,
      dialogVisible: false,
      formData: formJson,
      deleteLoading: false,
      busTypes: [],
      currentRow: {
        billNo: ""
      },
      actDateRange: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      bizQuery: {
        productName: null,
        orderIdFk: null,
        page: 1,
        limit: 10
      },
      bizTotal: 0,
      bizDetailLoading: false,
      bizDetailList: [],
      codeQuery: {
        orderIdFk: null,
        page: 1,
        limit: 10
      },
      codeTotal: 0,
      codeDetailLoading: false,
      codeDetailList: [],
      resultQuery: {
        orderId: null,
        code: null,
        page: 1,
        limit: 10
      },
      resultTotal: 0,
      resultDetailLoading: false,
      resultDetailList: [],
      acceptQuery: null,
      acceptOrderVisible: false,
    };
  },
  components: {AcceptOrder,DialogInvoice,InvoiceRegister},
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.filterQuery = {
        id: "",
        billNo: null,
        mainAction: null,
        action: null,
        page: 1,
        limit: 10,
        startTime: null,
        endTime: null,
        invCode: this.$store.getters.locInvCode,
      };
      this.getList();
    },
    InvoiceRegister(row){
      this.inputQueryId=row.billNo;
      this.InvoiceRegisterv=true;
    },
    onSubmit() {
      this.loading = true;
      if (this.actDateRange !== null) {
        this.filterQuery.startTime = this.actDateRange[0];
        this.filterQuery.endTime = this.actDateRange[1];
      } else {
        this.filterQuery.startTime = null;
        this.filterQuery.endTime = null;
      }
      this.filterQuery.page = 1;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    toViewCompanyCert(row){
      this.certFileUrl = this.BASE_URL + "/udiwms/image/register/file/getImage?type=image2&name=";
      window.open(this.certFileUrl + row.licenseUrl);
    },
    invChange() {
      this.filterQuery.action = null;
      this.getBusType();
    },
    freshen(){
      this.Upinvoice=false;
      this.getBizDetailList();
    },
    printOrder(row) {
      this.currentManufacturer = row;
      this.Upinvoice = true;
    },
    getBusType() {
      let query = {
        code: this.filterQuery.invCode,
        enabled: true,
      };
      getLocalJoinByUser(query)
        .then((response) => {
          this.busTypes = response.data.list || [];
        })
        .catch(() => {
        });
    },

    deleteInvoice(row){
      this.$confirm("此操作将永久删除该订单, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          let params={id:row}
          deleteById(params)
            .then((response) => {
              if (response.code == 20000) {
                this.getBizDetailList();
                this.$message({
                  type: "success",
                  message: "删除成功！",
                });
              }
            })
            .catch(() => {
            });
        })
        .catch(() => {
        });


    },
    handleSelectionChange(val) {
      this.currentRow = val;
      this.getOrderDetails();
    },
    // 获取单据 业务详情、扫码详情、扫码明细
    getOrderDetails() {
      this.bizQuery.page = 1;
      this.getBizDetailList();
    },
    // 清空单据详情数据列表
    clearDetailList() {
      // 清空业务详情
      this.bizDetailList = [];
      this.bizTotal = 0;
      // 清空扫码详情
      this.codeDetailList = [];
      this.codeTotal = 0;
      // 清空扫码明细
      this.resultDetailList = [];
      this.resultTotal = 0;
    },
    //获取订单列表
    getList() {
      this.loading = true;
      this.currentRow = {billNo: ""};
      this.clearDetailList();
      filterInvoice(this.filterQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.list = response.data.list || [];
            this.total = response.data.total || 0;
          } else {
            this.$message.error(response.message);
          }
        })
        .catch((error) => {
          this.$message.error(error.message)
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    deleteOrders(data) {
      this.loading = true;
      this.deleteData.billNo = data.billNo;
      deleteByOrderId(this.deleteData)
        .then((response) => {
          if (response.code == 20000) {
            this.getList();
            this.$message({
              type: "success",
              message: "删除成功！",
            });
          } else if (response.code == 520) {
            this.$message.error("新增扫码单据列表已不存在该扫码单据！");
            this.getList();
          }

        })
        .catch(() => {
        });
    },
    deleteDialog(row) {
      this.$confirm("此操作将永久删除该订单, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.deleteOrders(row);
        })
        .catch(() => {
        });
    },
    getInvList() {
      getInvListByUser()
        .then((response) => {
          this.invList = response.data || [];
        })
        .catch(() => {
        });
    },
    onBizReset() {
      this.bizQuery = {
        productName: null,
        orderIdFk: null,
        page: 1,
        limit: 10
      };
      this.getBizDetailList();
    },
    onBizSubmit() {
      this.bizQuery.page = 1;
      this.getBizDetailList();
    },
    getBizDetailList() {
      if (isBlank(this.currentRow.billNo)) {
        this.$message.error("请先选择需要查询的单据！")
        return;
      }
      this.bizDetailLoading = true;
      this.bizQuery.orderIdFk = this.currentRow.billNo;
      filterListInvoice(this.bizQuery).then((res) => {
        this.bizDetailLoading = false;
        if (res.code === 20000) {
          this.bizDetailList = res.data.list || [];
          this.bizTotal = res.data.total || 0;
        } else {
          this.$message.error(res.message);
          this.bizDetailList = [];
          this.bizTotal = 0;
        }
      }).catch((error) => {
        this.bizDetailLoading = false;
        this.$message.error(error.message);
        this.bizDetailList = [];
        this.bizTotal = 0;
      })
    },


    //单据撤回
    rollback(row) {
      this.$confirm('此操作将撤回单据至待校验, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let param = {billNo: row.billNo};
        rollUnReceivebackOrder(param).then((res) => {
          if (res.code === 20000) {
            this.$message.success("撤回成功");
            this.getList();
          } else {
            this.$message.error(res.message);
          }
        })
      }).catch(() => {
        // this.$message.info('回退失败');
      });
    },

    //验收结束
    closeAcceptDialog() {
      this.Upinvoice = false;
      this. getBizDetailList();
    },

    closeInvoice(){
      this.InvoiceRegisterv=false;
      this.getBizDetailList();
    },

    //开始验收
    reviewOrder(row) {
      this.acceptQuery = row;
      this.acceptOrderVisible = true;
    },

    parentByFn: function (childValue) {
      this.getList();
    },

    statusFilterType(status) {
      const statusMap = {
        5: "warning",
        1: "warning",
        6: "danger",
        7: "success",
      };
      return statusMap[status];
    },
  }
  ,
  mounted() {
    document.body.ondrop = function (event) {
      event.preventDefault();
      event.stopPropagation();
    };
  }
  ,
  created() {
    this.getInvList();
    this.getBusType();
    selectSysParamByKey({paramKey: "muti_inv_mode"}).then((res) => {
      if (res.code === 20000) {
        if (res.data.paramValue === "0") {
          this.enableDept = true;
        }
      }
    });
    this.getList();
  }
  ,
}
;
</script>

<style type="text/scss" lang="scss">
</style>

